=== debian/changelog ===
cvs-fast-export (1.55-1) unstable; urgency=medium

  * New upstream version 1.55
  * Bump debhelper dependency to "Build-Depends: debhelper-compat (= 13)"
  * Add cppcheck and shellcheck as build-dependencies as per upstream's
    new "buildprep" script
  * Refresh debian/patches

 -- Anthony Fok <foka@debian.org>  Thu, 05 Nov 2020 01:31:11 -0700
