=== debian/control ===
Source: cvs-fast-export
Maintainer: Anthony Fok <foka@debian.org>
Section: vcs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               bison,
               flex,
               python3,
               git,
               rcs,
               cvs,
               pylint,
               cppcheck,
               shellcheck,
               asciidoc-base,
               docbook-xml,
               docbook-xsl
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian/cvs-fast-export
Vcs-Git: https://salsa.debian.org/debian/cvs-fast-export.git
Homepage: http://www.catb.org/esr/cvs-fast-export/

Package: cvs-fast-export
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Recommends: reposurgeon,
            cvs,
            git,
            rsync
Suggests: rcs,
          brz
Description: Export an RCS or CVS history as a fast-import stream
 cvs-fast-export, formerly "parsecvs", does what its new name implies:
 exports CVS repositories in a format suitable for git fast-import.
 .
 This program analyzes a collection of RCS files in a CVS repository
 (or outside of one) and, when possible, emits an equivalent history
 in the form of a fast-import stream. Not all possible histories can
 be rendered this way; the program tries to emit useful warnings when
 it can't. The program can also produce a visualization of the
 resulting commit DAG in the DOT format handled by the graphviz suite.
 .
 The distribution includes a tool, cvssync, for fetching masters from
 CVS remote repositories so cvs-fast-export can see them.  You will
 need rsync installed to use it.
 .
 A wrapper script called cvsconvert runs a conversion to git and
 looks for content mismatches with the original CVS.  You will need
 CVS and Git installed to use it.
 .
 Also included is a tool called cvsreduce that strips content out of
 trees of RCS/CVS masters, leaving only metadata structure in place.
