=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

%:
	dh $@ --with python3 --no-parallel

execute_after_dh_auto_build:
	TZ=UTC asciidoc hacking.adoc

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

execute_after_dh_auto_clean:
	find tests -path '*/CVSROOT/history' -type f -exec sed -i '/|esr|/!d' '{}' \;
