=== tests/Makefile ===
--- 
+++ 
@@ -7,13 +7,14 @@
 CVS = cvs
 DIFF = diff -u -a
 CVS_FAST_EXPORT = ../cvs-fast-export $(OPTS)
+PYTHON = python3
 
 check: test
 
 .SUFFIXES: .tst .repo .testrepo .checkout .dot .fi ,v
 
 .tst.repo:
-	python $<
+	$(PYTHON) $<
 .repo.checkout:
 	$(CVS) -d :local:${CURDIR}/$*.repo -Q checkout module && mv module $*.checkout
 .repo.dot:
@@ -29,7 +30,7 @@
 ,v.dot:
 	$(CVS_FAST_EXPORT) -g $< >$*.dot
 
-test: s_regress m_regress r_regress i_regress t_regress c_regress sporadic # z2_regress z3_regress
+test: s_regress m_regress r_regress i_regress t_regress c_regress sporadic
 	@echo "No diff output is good news."
 
 rebuild: s_rebuild m_rebuild r_rebuild i_rebuild t_rebuild # z_rebuild
@@ -52,9 +53,9 @@
 s_regress: neutralize.map
 	@echo "== Dump regressions =="
 	@-for file in $(TESTLOADS); do \
-	    echo -n "  $${file} "; grep -a '##' $${file}.tst  || echo ' ## (no description)'; \
+	    legend=$$( ( grep -a '##' $${file}.tst || echo ' ## (no description)' ) | sed 's/## //' ); \
 	    $(MAKE) --quiet $${file}.repo; \
-	    find $${file}.repo/module -name '*,v' | $(CVS_FAST_EXPORT) $(TESTOPTS) 2>&1 | $(DIFF) $${file}.chk -; \
+	    find $${file}.repo/module -name '*,v' | $(CVS_FAST_EXPORT) $(TESTOPTS) 2>&1 | tapdiffer "$${legend}" $${file}.chk; \
 	done
 
 MASTERS := $(shell ls -1 *,v | sed '/,v/s///')
@@ -66,8 +67,8 @@
 m_regress:
 	@echo "== Master-parsing regressions =="
 	@-for file in $(MASTERS); do \
-	    echo -n "  $${file}: "; sed <$${file},v -n -e '/^comment[	 ]*@# \(.*\)@;/s//\1/p'; \
-	    $(CVS_FAST_EXPORT) $${file},v 2>&1 | $(DIFF) $${file}.chk -; \
+	    legend=$$(sed <$${file},v -n -e '/^comment[	 ]*@# \(.*\)@;/s//\1/p'); \
+	    $(CVS_FAST_EXPORT) $${file},v 2>&1 | tapdiffer "$${legend}" $${file}.chk; \
 	done
 
 INCREMENTAL=twobranch
@@ -81,9 +82,9 @@
 i_regress: neutralize.map
 	@echo "== Incremental-dump regressions =="
 	@-for file in $(INCREMENTAL); do \
-	    echo -n "  $${file} "; grep -a '##' $${file}.tst  || echo ' ## (no description)'; \
+	    legend=$$( ( grep -a '##' $${file}.tst  || echo ' ## (no description)') | sed 's/## //' ); \
 	    $(MAKE) --quiet $${file}.repo; \
-	    find $${file}.repo/module -name '*,v' | $(CVS_FAST_EXPORT) -T -i $(THRESHOLD) -A neutralize.map 2>&1 | $(DIFF) $${file}.inc-chk -; \
+	    find $${file}.repo/module -name '*,v' | $(CVS_FAST_EXPORT) -T -i $(THRESHOLD) -A neutralize.map 2>&1 | tapdiffer "$${legend}" $${file}.inc-chk; \
 	done
 
 REDUCED=oldhead
@@ -95,8 +96,8 @@
 r_regress: neutralize.map
 	@echo "== Repo regressions =="
 	@-for repo in $(REDUCED); do \
-	    echo -n "  $${repo} "; grep -a '##' $${repo}.testrepo/README  || echo ' ## (no description)'; \
-	    find $${repo}.testrepo/module -name '*,v' | $(CVS_FAST_EXPORT) $(TESTOPTS) 2>&1 | $(DIFF) $${repo}.chk -; \
+	    legend=$$( ( grep -a '##' $${repo}.testrepo/README  || echo ' ## (no description)') | sed 's/## //' ); \
+	    find $${repo}.testrepo/module -name '*,v' | $(CVS_FAST_EXPORT) $(TESTOPTS) 2>&1 | tapdiffer "$${legend}" $${repo}.chk; \
 	done
 
 PYTESTS=t9601 t9602 t9603 t9604 t9605
@@ -104,13 +105,13 @@
 t_regress:
 	@echo "== Pathological cases =="
 	@for pytest in $(PYTESTS); do \
-		echo -n "  $${pytest} "; grep -a '##' $${pytest}.py  || echo ' ## (no description)'; \
-		python $${pytest}.py 2>&1 | $(PATHSTRIP) | $(DIFF) $${pytest}.err -; \
+		legend=$$( ( grep -a '##' $${pytest}.py  || echo ' ## (no description)') | sed 's/## //' ); \
+		$(PYTHON) $${pytest}.py 2>&1 | $(PATHSTRIP) | tapdiffer "$${legend}" $${pytest}.err; \
 	done
 t_rebuild:
 	@for pytest in $(PYTESTS); do \
 		echo "Remaking $${pytest}.err "; \
-		python $${pytest}.py 2>&1 | $(PATHSTRIP) >$${pytest}.err; \
+		$(PYTHON) $${pytest}.py 2>&1 | $(PATHSTRIP) >$${pytest}.err; \
 	done
 
 # Omitted:
@@ -135,24 +136,14 @@
 	@for rtest in $(UNSTRIPPED); do \
 		base=`basename $${rtest}`; \
 		echo "  $${base}"; \
-		cvsreduce <$${rtest} | $(DIFF) reductions/$${base}.reduced -; \
+		cvsstrip <$${rtest} | $(DIFF) reductions/$${base}.reduced -; \
 	done
 z_rebuild:
 	@for rtest in $(UNSTRIPPED); do \
 		base=`basename $${rtest}`; \
 		echo "Remaking $${base}.reduced "; \
-		cvsreduce <$${rtest} >reductions/$${base}.reduced; \
+		cvsstrip <$${rtest} >reductions/$${base}.reduced; \
 	done
-
-z2_regress:
-	setpython python2
-	make z_regress
-	setpython python
-
-z3_regress:
-	setpython python3
-	make z_regress
-	setpython python
 
 sporadic:
 	@echo "== Sporadic tests =="
