=== debian/changelog ===
cvs-fast-export (1.59-1) unstable; urgency=medium

  * New upstream version 1.59
  * Change "cvsreduce" to "cvsstrip" in package description
    to reflect the rename since version 1.56
  * Remove override_dh_python3 used for forced shebang, and
    remove 03-use-python3-only-for-tests.patch too,
    as upstream has switched all python invocations to python3 in 1.59
  * Use dh-sequence-python3 instead of dh-python and "--with python3"
  * Bump Standards-Version to 4.6.0 (no change)

 -- Anthony Fok <foka@debian.org>  Fri, 03 Dec 2021 01:58:34 -0700
