=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: vcs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                bison,
                flex,
                python3,
@@ -16,7 +16,7 @@
                asciidoc-base,
                docbook-xml,
                docbook-xsl
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian/cvs-fast-export
 Vcs-Git: https://salsa.debian.org/debian/cvs-fast-export.git
 Homepage: http://www.catb.org/esr/cvs-fast-export/
@@ -51,5 +51,5 @@
  looks for content mismatches with the original CVS.  You will need
  CVS and Git installed to use it.
  .
- Also included is a tool called cvsreduce that strips content out of
+ Also included is a tool called cvsstrip that strips content out of
  trees of RCS/CVS masters, leaving only metadata structure in place.
