=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

%:
	dh $@ --no-parallel

execute_after_dh_auto_build:
	TZ=UTC asciidoc hacking.adoc

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

execute_after_dh_auto_clean:
	find tests -path '*/CVSROOT/history' -type f -exec sed -i '/|esr|/!d' '{}' \;
